/* This header file is shared with compare, John's display programme.
 *					Chris, August 1999
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <stdio.h> 
#include <math.h>

#ifndef lo_limit
#define lo_limit(a) ((a)<(-355) ? (a+360) : (a))
#endif
#ifndef hi_limit
#define hi_limit(a) ((a)>(355) ? (a-360) : (a))
#endif
#ifndef min
#define min(a,b) ((a)<(b) ? (a) : (b))
#endif
#ifndef max
#define max(a,b) ((a)>(b) ? (a) : (b))
#endif
#ifndef inbtw
#define inbtw(a,lo,hi) ((a > lo) && (a < hi))
#endif
#ifndef outsd
#define outsd(a,lo,hi) ((a < lo) || (a > hi))
#endif

#define PI 3.141592653589793
#define deg_per_rad 57.29577951
#define NO     0
#define YES    1
#define SUCCESS 1
#define FAILURE 0
#define DATA 0
#define MODEL 1
#define ORIG_MODEL 2
#define SCALE_R 500
#define SCALE_V 100
#define CORE_RADIUS 100
#define N 2

/* THESE VARIABLES MUST AGREE WITH colorname[] and grayname[] arrays
   in CreateColorMap.c */
#define MAX_COLORS 42

struct particle 
{
	float x,y,z;		/* assumed in pixels */
	float vx,vy,vz;		/* assumed in pixels */
	float phi;		/* assumed in mJy/b or ??*/
	float GM,E,L;
	float a,e,period;
	int rad,rank,key;
};

struct particle *points[3];       
/* points[0]=data; points[1]=model; points[2]=original model */

float min_flux,V_sys,scale_r[N],scale_v[N],in2out_r,in2out_v;
int npoints[N],type,circle,vector,group,release,do_velocity,DoMenu;
int debug;       /* This is used for debugging. Set to yes to
                  * display printfs.
                  */

int boxsz,box1_x,box1_y,box2_x,box2_y,sy,sdy;

struct numbers {
	int npoints;		/* total number of points */
	int npoints1,npoints2;	/* total number in individual galaxies */
	int disk1,disk2;	/* numbers in galaxies' disks */
	int bulge1,bulge2;	/* numbers in galaxies' bulges */
	int halo1,halo2;	/* numbers in galaxies' halos */
};


int position(FILE *file, struct particle *p_data);
int velocity(FILE *file, struct particle *p_data);
int xyvz(FILE *file, struct particle *p_data);
int velocity_vector(FILE *file, struct particle *p_data);
void file_root(char *filename);

FILE *fopen(),*log_file;
FILE *fopen(),*xyz;
FILE *fopen(),*VxVyVz;
FILE *fopen(),*xyVz;
FILE *fopen(),*xyzVxVyVz;
FILE *fopen(),*all;

struct numbers *gal;
char *original;




