#include "compare.h"

void output(char *filename, int out, struct particle *p_data)
{
char *file;
int i;

file_root(original);

 switch(out) {

 case 1:                                                /* Position */

   file=(char *) malloc((strlen(original)+5)*sizeof(char));
   if(file==NULL)
    {
     printf("Error : Could not allocate memory. Exiting....\n");
     exit(0);
    }
  
  sprintf(file,"%sxyz",original);
  
  if((xyz=fopen(file,"w"))==NULL)
   {
    fprintf(stderr,"Couldn't open %s for writing. Exiting....\n",file);
    exit(-1);
   }
  
  fprintf(xyz,"appearance { material { edgecolor 1 1 1 } } { LIST\n");
    position(xyz,p_data);
  fprintf(xyz,"}");

  fclose(xyz);
  free(file);

  break;

 case 2:                                           /* Velocity */
   file=(char *) malloc((strlen(original)+8)*sizeof(char));
   if(file==NULL)
    {
     printf("Error : Could not allocate memory. Exiting....\n");
     exit(0);
    }
  
  sprintf(file,"%sVxVyVz",original);
  
  if((VxVyVz=fopen(file,"w"))==NULL)
   {
    fprintf(stderr,"Couldn't open %s for writing. Exiting....\n",file);
    exit(-1);
   }
  
  fprintf(VxVyVz,"appearance { material { edgecolor 1 1 1 } } { LIST\n");
    velocity(VxVyVz,p_data);
  fprintf(VxVyVz,"}");

  fclose(VxVyVz);
  free(file);

  break;
 
 case 3:                                          /* Position, Velocity */
 
   file=(char *) malloc((strlen(original)+5)*sizeof(char));
   if(file==NULL)
    {
     printf("Error : Could not allocate memory. Exiting....\n");
     exit(0);
    }
  sprintf(file,"%sxyVz",original);
  
  if((xyVz=fopen(file,"w"))==NULL)
   {
    fprintf(stderr,"Couldn't open %s for writing. Exiting....\n",file);
    exit(-1);
   }
  
  fprintf(xyVz,"appearance { material { edgecolor 1 1 1 } } { LIST\n");
    xyvz(xyVz,p_data);
  fprintf(xyVz,"}");

  fclose(xyVz);
  free(file);

  break;

 case 4:                                       /* Position, Velocity Vector */
 
   file=(char *) malloc((strlen(original)+10)*sizeof(char));
   if(file==NULL)
    {
     printf("Error : Could not allocate memory. Exiting....\n");
     exit(0);
    }
  
  sprintf(file,"%sxyzVxVyVz",original);
  
  if((xyzVxVyVz=fopen(file,"w"))==NULL)
   {
    fprintf(stderr,"Couldn't open %s for writing. Exiting....\n",file);
    exit(-1);
   }
  
  fprintf(xyzVxVyVz,"appearance { material { edgecolor 1 1 1 } } { LIST\n");
    position(xyzVxVyVz,p_data);
    velocity_vector(xyzVxVyVz,p_data);
  fprintf(xyzVxVyVz,"}");

  fclose(xyzVxVyVz);
  free(file);

  break;

 case 5:
   file=(char *) malloc((strlen(original)+10)*sizeof(char));
   if(file==NULL)
    {
     printf("Error : Could not allocate memory. Exiting....\n");
     exit(0);
    }
   for(i=1;i<=4;i++){ switch(i) {
                        case 1: sprintf(file,"%sxyz",original); break;
                        case 2: sprintf(file,"%sVxVyVz",original); break;
                        case 3: sprintf(file,"%sxyVz",original); break;
                        case 4: sprintf(file,"%sxyzVxVyVz",original); break;
                        default: break;
                        } printf("Now processing %s\n",file);
                         if((all=fopen(file,"w"))==NULL)
                      {
                       fprintf(stderr,"Couldn't open %s for writing. Exiting....\n",file);
                       exit(-1);
                      }
  
         fprintf(all,"appearance { material { edgecolor 1 1 1 } } { LIST\n");
         switch(i) {
	  case 1:  position(all,p_data); break;
	  case 2:  velocity(all,p_data); break;
	  case 3:  xyvz(all,p_data); break;
	  case 4:  position(all,p_data);
                   velocity_vector(all,p_data);
		   break;
	           }
	 fprintf(all,"}");
         fclose(all);
   
         
	 }
  free(file);
  break;
   
 default:
  break;
 }
}

void file_root(char *filename)
{
int i,j;
char tmp[5];

 if(filename[0]=='.' && filename[1]=='/')
  {
       j=2;
       while(filename[j]!='.'&&j<=(strlen(filename)-2))
	 {
	   tmp[j-2]=filename[j];
	   j++;
	 }
       tmp[j-2]='\0';
  }
 else {
for(i=0;i<=strlen(filename);i++)
  { 
    if(filename[i]=='.')
    {
     for(j=0;j<i;j++)
	 {
         tmp[j]=filename[j];
	 }
     tmp[i]='\0';
     break;
     }
    else
     {
      tmp[i]=filename[i];
        if(i==strlen(filename)) 
         {
         tmp[i]='\0';
         break;
	 }
     }
  }
 }
sprintf(filename,"%s",tmp);
}
/* ==========================================================================
   This function produces position data in a single oogl file
   ==========================================================================*/

int position(FILE *file, struct particle *p_data)
{
struct particle *pp;
int NPTS=npoints[type];
int i;
fprintf(file,"\n\n appearance { linewidth 5 } VECT %d %d %d\n",NPTS,NPTS,NPTS);
for(i=1;i<=NPTS;i++) fprintf(file,"1 ");
fprintf(file,"\n");
for(i=1;i<=NPTS;i++) fprintf(file,"1 ");
fprintf(file,"\n");

for(pp=p_data;pp<(p_data+NPTS);pp++) 
	{
	fprintf(file,"\n%lf %lf %lf\n",(*pp).x,(*pp).y,(*pp).z); 
	}
fprintf(file,"\n\n");
for(i=1;i<=NPTS/2;i++) fprintf(file,"1 0 0 1\n");
for(i=(NPTS/2)+1;i<=NPTS;i++) fprintf(file,"0 0 1 1\n");

return SUCCESS;
}



int velocity(FILE *file, struct particle *p_data)
{
struct particle *pp;
int NPTS=npoints[type];
int i;
fprintf(file,"\n\n appearance { linewidth 5 } VECT %d %d %d\n",NPTS,NPTS,NPTS/NPTS);
for(i=1;i<=NPTS;i++) fprintf(file,"1 ");
fprintf(file,"\n");
fprintf(file,"1 ");
for(i=2;i<=NPTS;i++) fprintf(file,"0 ");
fprintf(file,"\n");

for(pp=p_data;pp<(p_data+NPTS);pp++) 
	{
	fprintf(file,"\n%lf %lf %lf\n",(*pp).vx,(*pp).vy,(*pp).vz); 
	}
fprintf(file,"\n\n");
fprintf(file,"0 1 0 1\n");

return SUCCESS;
}



int xyvz(FILE *file, struct particle *p_data)
{
struct particle *pp;
int NPTS=npoints[type];
int i;
fprintf(file,"\n\n appearance { linewidth 5 } VECT %d %d %d\n",NPTS,NPTS,NPTS);
for(i=1;i<=NPTS;i++) fprintf(file,"1 ");
fprintf(file,"\n");
for(i=1;i<=NPTS;i++) fprintf(file,"1 ");
fprintf(file,"\n");

for(pp=p_data;pp<(p_data+NPTS);pp++) 
	{
	fprintf(file,"\n%lf %lf %lf\n",(*pp).x,(*pp).y,(*pp).vz); 
	}
fprintf(file,"\n\n");
for(i=1;i<=NPTS/2;i++) fprintf(file,"1 0 0 1\n");
for(i=(NPTS/2)+1;i<=NPTS;i++) fprintf(file,"0 0 1 1\n");

return SUCCESS;
}



int velocity_vector(FILE *file, struct particle *p_data)
{
struct particle *pp;
int NPTS=npoints[type];
float vscale=1.0;
int i;
fprintf(file,"\n\n appearance { linewidth 1 } VECT %d %d %d\n",NPTS,2*NPTS,NPTS);
for(i=1;i<=NPTS;i++) fprintf(file,"2 ");
fprintf(file,"\n");
for(i=1;i<=NPTS;i++) fprintf(file,"1 ");
fprintf(file,"\n");

for(pp=p_data;pp<(p_data+NPTS);pp++) 
	{
	fprintf(file,"\n%lf %lf %lf",(*pp).x,(*pp).y,(*pp).z);
	if((*pp).x+(*pp).y+(*pp).z<CORE_RADIUS) vscale=SCALE_V/2;
      	fprintf(file,"\n%lf %lf %lf",((*pp).x+((*pp).vx)/vscale),\
	     ((*pp).y+((*pp).vy)/vscale),((*pp).z+((*pp).vz)/vscale));
	}
fprintf(file,"\n\n");
for(i=1;i<=NPTS/2;i++) fprintf(file,"1 1 1 1\n");
for(i=(NPTS/2)+1;i<=NPTS;i++) fprintf(file,"0 0 0 1\n");

return SUCCESS;
}

int velocity_condition()
{
}






