#include "compare.h"

FILE *fopen(), *input;

void process_infile(char *filename)
{
  FILE *fopen(), *input;
  char buffer[132];
  char filetype[5];
  char outtype[5];
  struct particle *p_internal;
  struct numbers *gal;
  int npoints1,npoints2,disk1,disk2;
  int out;
 
  gal=(struct numbers *) malloc(4*sizeof(int));

  if(gal==NULL)
    {
      printf("Error: Could not allocate memory! Exiting...\n");
      exit(0);
    }

  printf("Trying to open the input file : %s...\n",filename);
  if((input=fopen(filename,"r"))==NULL)
   {
     fprintf(stderr,"Couldn't open %s for reading. Exiting....\n",filename);
     exit(-1);
   }
  else
   {
    printf("Successfully opened %s!\n",filename);
   }
 

  while (fgets(buffer,132,input)!=NULL)
   {
   sscanf(buffer,"%s %s %d %d %d %d %s",filetype,filename,&npoints1,&disk1,&npoints2,&disk2,outtype);
   (*gal).npoints1=npoints1;
   (*gal).disk1=disk1;
   (*gal).npoints2=npoints2;
   (*gal).disk2=disk2;
   printf("%d %d %d %d",(*gal).npoints1,(*gal).npoints2,(*gal).disk1,(*gal).disk2);
 }    

 if(strncmp(outtype,"pos",3)==0) out=1;
 else if(strncmp(outtype,"vel",3)==0) out=2;
 else if(strncmp(outtype,"pvel",4)==0) out=3;
 else if(strncmp(outtype,"pvec",4)==0) out=4;
 else if(strncmp(outtype,"all",3)==0) out=5;

     if(strncmp(buffer,"p",1)==0)
      {
       	p_internal=read_data(filename);
	output(filename,out,p_internal);
      }
    else if(strncmp(filetype,"snap",4)==0) 
      {
	p_internal=read_snap(filename);
	output(filename,out,p_internal);
      }
    else if(strncmp(filetype,"zeno",4)==0)
      {
	p_internal=read_zeno(filename);
	output(filename,out,p_internal);
      }


printf("\nFile successfully converted. Output in ");
 switch(out){
  case 1: printf("xyz.oogl.\n"); break;
  case 2: printf("VxVyVz.oogl.\n"); break;
  case 3: printf("xyVz.oogl.\n"); break;
  case 4: printf("xyzVxVyVz.oogl.\n"); break;
  case 5: printf("xyz.oogl, VxVyVz.oogl,xyVz.oogl and xyzVxVyVz.oogl.\n"); break;
  default: break;
 }
}
  










